/**
 * @file
 */

(function ($, Drupal) {
    Drupal.behaviors.gamw = {
        attach: function (context, settings) {
            $('div[id^="gamw"]', context).each(
                function () {
                    var uuid = $(this).attr("data-uuid");
                    var ad_unit = $(this).attr("data-ad-unit");
                    var gamw_settings = settings.gamw.blocks[ad_unit][uuid];
                    var sizes_object = {};
                    for (var key in gamw_settings.sizes) {
                        for (var key2 in gamw_settings.sizes[key]) {
                            var array2 = gamw_settings.sizes[key][key2];
                            sizes_object[key2] = array2;
                        }
                    }
                    var all_sizes = [];
                    for (var key in sizes_object) {
                        all_sizes.push(sizes_object[key]);
                    }

                    Drupal.gamw.googletag.cmd.push(
                        function () {
                            var mapping = Drupal.gamw.googletag.sizeMapping();
                            $.each(
                                gamw_settings.sizes, function (index, value) {
                                    var mapping_sizes = [];
                                    for (var key in value) {
                                        mapping_sizes.push(value[key]);
                                    }
                                    mapping.addSize([parseInt(index), 0], mapping_sizes);
                                }
                            );
                            var mapping_actual = mapping.build();

                            var slot_definition = Drupal.gamw.googletag.defineSlot("/" + gamw_settings.gamw_id + "/" + gamw_settings.ad_unit, all_sizes, "gamw_" + gamw_settings.uuid);
                            if (slot_definition != undefined) {
                                    slot_definition.defineSizeMapping(mapping_actual).addService(Drupal.gamw.googletag.pubads());
                                    $.each(
                                        gamw_settings.targeting_attributes, function (index, value) {
                                            slot_definition.setTargeting(index, value);
                                        }
                                    );
                                      Drupal.gamw.googletag.gptAdSlots.push(slot_definition);
                            }
                            Drupal.gamw.googletag.pubads().enableSingleRequest();
                            if (gamw_settings.collapsed) {
                                      Drupal.gamw.googletag.pubads().collapseEmptyDivs();
                            }
                            Drupal.gamw.googletag.enableServices();
                            Drupal.gamw.googletag.display("gamw_" + gamw_settings.uuid);
                            if (gamw_settings.dev_mode) {
                                console.log("GAMW Advertisement-(" + ad_unit + "): ", gamw_settings);
                            }
                        }
                    );
                }
            );
        }
    };
})(jQuery, Drupal);
